const Main         = imports.ui.main;
const ViewSelector = imports.ui.main.overview._viewSelector;

const ExtensionUtils = imports.misc.extensionUtils;
const Me = ExtensionUtils.getCurrentExtension();

const Apps = Me.imports.apps;

let searchCancelled = {};
let doSearch        = {};

let activate     = {};
let workspaces   = {};
let applications = {};
let search       = {};

function init() {
    searchCancelled = ViewSelector._searchCancelled;
    doSearch = ViewSelector._doSearch;

	activate = function (page) {
	    if (Main.overview.visible && ViewSelector._searchCancelled != page) {
		    ViewSelector._searchCancelled = page;
		    page();
	    } else {
		    Main.overview.toggle();
	    }
	    if (Main.overview.visible) {
		    ViewSelector._searchCancelled = page;
		    page();
	    }
	};
	workspaces = function() {
	    ViewSelector._searchResults.reset();
	    ViewSelector._entry.hide();
	    ViewSelector._showPage(ViewSelector._workspacesPage);
	};
	applications = function() {
	    ViewSelector._searchResults.reset();
	    ViewSelector._entry.hide();
	    ViewSelector._showPage(ViewSelector._searchPage);
	    ViewSelector._entry.text = '';
	    ViewSelector._text.set_selection(-1, -1);
	    ViewSelector._searchTimeoutId = 0;
	    ViewSelector._searchResults.doSearch(Apps.SEARCH_CATEGORY);
	};
	search = function() {
	    ViewSelector._searchResults.reset();
	    ViewSelector._entry.show();
	    ViewSelector._showPage(ViewSelector._searchPage);
	};
}

function enable() {
    ViewSelector._doSearch = function() {
        ViewSelector._showPage(ViewSelector._searchPage);
	    ViewSelector._entry.show();
        ViewSelector._text.set_selection(-1, -1);
        ViewSelector._searchTimeoutId = 0;
        let text = ViewSelector._text.get_text().replace(/^\s+/g, '').replace(/\s+$/g, '');
        ViewSelector._searchResults.doSearch(text);
    };
}

function disable() {
    ViewSelector._searchCancelled = searchCancelled;
    ViewSelector._doSearch = doSearch;
}
